## ros-r2b3-tf2-ros 0.5.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(tf2_ros)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(NOT ANDROID)
set(TF2_PY tf2_py)
endif()

find_package(ament_cmake REQUIRED)
# TODO(tfoote) uncomment when reenabling server client interfaces
# find_package(actionlib REQUIRED)
# find_package(actionlib_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_msgs REQUIRED)

find_package(rmw)

# This is necessary due to console bridge installing to a non-standard location
# https://github.com/ros2/ros2/issues/195
if(UNIX AND NOT APPLE)
  ament_environment_hooks(env_hook/console_bridge_libs.sh)
endif()

include_directories(include
  ${geometry_msgs_INCLUDE_DIRS}
  ${rclcpp_INCLUDE_DIRS}
  ${rmw_INCLUDE_DIRS}
  ${rmw_implementation_INCLUDE_DIRS}
  ${tf2_INCLUDE_DIRS}
  ${tf2_msgs_INCLUDE_DIRS}
  )

# tf2_ros library
add_library(${PROJECT_NAME} SHARED
  src/buffer.cpp
  src/transform_listener.cpp
  # src/buffer_client.cpp
  # src/buffer_server.cpp
  src/transform_broadcaster.cpp
  src/static_transform_broadcaster.cpp
)

target_link_libraries(${PROJECT_NAME}
  ${geometry_msgs_LIBRARIES}
  ${rclcpp_LIBRARIES}
  ${rmw_LIBRARIES}
  ${rmw_implementation_LIBRARIES}
  ${tf2_LIBRARIES}
  ${tf2_msgs_LIBRARIES}
  )

target_compile_definitions(${PROJECT_NAME} PRIVATE "TF2_ROS_BUILDING_DLL")
# TODO(tfoote) port server client interfaces
# # buffer_server executable
# add_executable(buffer_server src/buffer_server_main.cpp)
# add_dependencies(${PROJECT_NAME}_buffer_server tf2_msgs_gencpp)
# target_link_libraries(${PROJECT_NAME}_buffer_server
#   ${PROJECT_NAME}
#   ${catkin_LIBRARIES}
#   ${Boost_LIBRARIES}
# )


# static_transform_publisher
add_executable(static_transform_publisher
  src/static_transform_broadcaster_program.cpp
)
target_link_libraries(static_transform_publisher
  ${PROJECT_NAME}
  ${geometry_msgs_LIBRARIES}
  ${rclcpp_LIBRARIES}
  ${rmw_LIBRARIES}
  ${rmw_implementation_LIBRARIES}
  ${tf2_LIBRARIES}
  ${tf2_msgs_LIBRARIES}
  )

add_executable(tf2_echo
  src/tf2_echo.cpp
)
target_link_libraries(tf2_echo
  ${PROJECT_NAME}
  ${geometry_msgs_LIBRARIES}
  ${rclcpp_LIBRARIES}
  ${rmw_LIBRARIES}
  ${rmw_implementation_LIBRARIES}
  ${tf2_LIBRARIES}
  ${tf2_msgs_LIBRARIES}
  )

  add_executable(tf2_monitor
    src/tf2_monitor.cpp
  )
  target_link_libraries(tf2_monitor
    ${PROJECT_NAME}
    ${geometry_msgs_LIBRARIES}
    ${rclcpp_LIBRARIES}
    ${rmw_LIBRARIES}
    ${rmw_implementation_LIBRARIES}
    ${tf2_LIBRARIES}
    ${tf2_msgs_LIBRARIES}
    )

# Install rules
install(TARGETS
  ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# install executables
install(TARGETS
  # buffer_server
  static_transform_publisher
  tf2_echo
  tf2_monitor
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
)


# Tests
# if(BUILD_TESTING)
# TODO(tfoote) port tests to use ROS2 instead of ROS1 api.
if (false)

# new requirements for testing
find_package(catkin REQUIRED COMPONENTS
  actionlib
  actionlib_msgs
  geometry_msgs
  message_filters
  roscpp
  rosgraph
  rospy
  rostest
  tf2
  tf2_msgs
  ${TF2_PY}
)



# tf2_ros_test_listener
add_executable(${PROJECT_NAME}_test_listener EXCLUDE_FROM_ALL test/listener_unittest.cpp)
add_dependencies(${PROJECT_NAME}_test_listener tf2_msgs_gencpp)
add_executable(${PROJECT_NAME}_test_time_reset EXCLUDE_FROM_ALL test/time_reset_test.cpp)
add_dependencies(${PROJECT_NAME}_test_time_reset tf2_msgs_gencpp)
target_link_libraries(${PROJECT_NAME}_test_listener
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${GTEST_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME}_test_time_reset
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${GTEST_LIBRARIES}
)

add_dependencies(tests ${PROJECT_NAME}_test_listener)
add_dependencies(tests ${PROJECT_NAME}_test_time_reset)

add_rostest(test/transform_listener_unittest.launch)
add_rostest(test/transform_listener_time_reset_test.launch)

endif()
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(rclcpp)
ament_export_dependencies(tf2_msgs)
ament_package()

=== debian/changelog ===
ros-r2b3-tf2-ros (0.5.15-8xenial) xenial; urgency=high

  * tf2_ros: add option to unregister TransformListener (#201 <https://github.com/ros/geometry2/issues/201>)
  * Contributors: Hans-Joachim Krauch

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 24 Jan 2017 05:00:00 -0000

ros-r2b3-tf2-ros (0.5.14-8xenial) xenial; urgency=high

  * Drop roslib.load_manifest (#191 <https://github.com/ros/geometry2/issues/191>)
  * Adds ability to load TF from the ROS parameter server.
  * Code linting & reorganization
  * Fix indexing beyond end of array
  * added a static transform broadcaster in python
  * lots more documentation
  * remove BufferCore doc, add BufferClient/BufferServer doc for C++, add Buffer/BufferInterface Python documentation
  * Better overview for Python
  * Contributors: Eric Wieser, Felix Duvallet, Jackie Kay, Mikael Arguedas, Mike Purvis

 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 16 Jan 2017 05:00:00 -0000

ros-r2b3-tf2-ros (0.5.13-8xenial) xenial; urgency=high

  * fix documentation warnings
  * Adding tests to package
  * Contributors: Laurent GEORGE, Vincent Rabaud

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 04 Mar 2016 05:00:00 -0000

ros-r2b3-tf2-ros (0.5.12-8xenial) xenial; urgency=high

  * remove annoying gcc warning
    This is because the roslog macro cannot have two arguments that are
    formatting strings: we need to concatenate them first.
  * break canTransform loop only for non-tiny negative time deltas
    (At least) with Python 2 ros.Time.now() is not necessarily monotonic
    and one can experience negative time deltas (usually well below 1s)
    on real hardware under full load. This check was originally introduced
    to allow for backjumps with rosbag replays, and only there it makes sense.
    So we'll add a small duration threshold to ignore backjumps due to
    non-monotonic clocks.
  * Contributors: Vincent Rabaud, v4hn

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 05 Aug 2015 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.11-8xenial) xenial; urgency=high

  * do not short circuit waitForTransform timeout when running inside pytf. Fixes #102 <https://github.com/ros/geometry_experimental/issues/102>
    roscpp is not initialized inside pytf which means that ros::ok is not
    valid. This was causing the timer to abort immediately.
    This breaks support for pytf with respect to early breaking out of a loop re #26 <https://github.com/ros/geometry_experimental/issues/26>.
    This is conceptually broken in pytf, and is fixed in tf2_ros python implementation.
    If you want this behavior I recommend switching to the tf2 python bindings.
  * inject timeout information into error string for canTransform with timeout
  * Contributors: Tully Foote

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 22 Apr 2015 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.10-8xenial) xenial; urgency=high

  * switch to use a shared lock with upgrade instead of only a unique lock. For #91 <https://github.com/ros/geometry_experimental/issues/91>
  * Update message_filter.h
  * filters: fix unsupported old messages with frame_id starting with '/'
  * Enabled tf2 documentation
  * make sure the messages get processed before testing the effects. Fixes #88 <https://github.com/ros/geometry_experimental/issues/88>
  * allowing to use message filters with PCL types
  * Contributors: Brice Rebsamen, Jackie Kay, Tully Foote, Vincent Rabaud, jmtatsch

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 21 Apr 2015 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.9-8xenial) xenial; urgency=high

  * changed queue_size in Python transform boradcaster to match that in c++
  * Contributors: mrath

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 25 Mar 2015 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.8-8xenial) xenial; urgency=high

  * fix deadlock #79 <https://github.com/ros/geometry_experimental/issues/79>
  * break out of loop if ros is shutdown. Fixes #26 <https://github.com/ros/geometry_experimental/issues/26>
  * remove useless Makefile files
  * Fix static broadcaster with rpy args
  * Contributors: Paul Bovbel, Tully Foote, Vincent Rabaud

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 17 Mar 2015 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.7-8xenial) xenial; urgency=high

  * Added 6 param transform again
    Yes, using Euler angles is a bad habit. But it is much more convenient if you just need a rotation by 90° somewhere to set it up in Euler angles. So I added the option to supply only the 3 angles.
  * Remove tf2_py dependency for Android
  * Contributors: Achim Königs, Gary Servin

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 23 Dec 2014 05:00:00 -0000

ros-r2b3-tf2-ros (0.5.6-8xenial) xenial; urgency=high

  * support if canTransform(...): in python #57 <https://github.com/ros/geometry_experimental/issues/57>
  * Support clearing the cache when time jumps backwards #68 <https://github.com/ros/geometry_experimental/issues/68>
  * Contributors: Tully Foote

 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 18 Sep 2014 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.5-8xenial) xenial; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 23 Jun 2014 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.4-8xenial) xenial; urgency=high

  * surpressing autostart on the server objects to not incur warnings
  * switch to boost signals2 following ros/ros_comm#267 <https://github.com/ros/ros_comm/issues/267>, blocking ros/geometry#23 <https://github.com/ros/geometry/issues/23>
  * fix compilation with gcc 4.9
  * make can_transform correctly wait
  * explicitly set the publish queue size for rospy
  * Contributors: Tully Foote, Vincent Rabaud, v4hn

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 07 May 2014 04:00:00 -0000

ros-r2b3-tf2-ros (0.5.3-8xenial) xenial; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 21 Feb 2014 05:00:00 -0000

ros-r2b3-tf2-ros (0.5.2-8xenial) xenial; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 20 Feb 2014 05:00:00 -0000



=== debian/control ===
Source: ros-r2b3-tf2-ros
Section: misc
Priority: extra
Maintainer: Tully Foote <tfoote@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-r2b3-ament-cmake, ros-r2b3-geometry-msgs, ros-r2b3-rclcpp, ros-r2b3-std-msgs, ros-r2b3-tf2, ros-r2b3-tf2-msgs, ros-r2b3-ros-workspace
Homepage: http://www.ros.org/wiki/tf2_ros
Standards-Version: 3.9.2

Package: ros-r2b3-tf2-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-r2b3-geometry-msgs, ros-r2b3-rclcpp, ros-r2b3-std-msgs, ros-r2b3-tf2, ros-r2b3-tf2-msgs, ros-r2b3-ros-workspace
Description: This package contains the ROS bindings for the tf2 library, for both Python and C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/r2b3/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/r2b3" \
		-DAMENT_PREFIX_PATH="/opt/ros/r2b3"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-r2b3-tf2-ros//opt/ros/r2b3/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b3/setup.sh" ]; then . "/opt/ros/r2b3/setup.sh"; fi && \
	dh_auto_install
